unit options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, IniFiles, FileCtrl;

type
  TfmOptions = class(TForm)
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label12: TLabel;
    lblTimerInt: TLabel;
    tbTimerInterval: TTrackBar;
    GroupBox2: TGroupBox;
    rbAcqManu: TRadioButton;
    rbAcqAuto: TRadioButton;
    btnProgDate: TButton;
    GroupBox3: TGroupBox;
    cbHardWare: TComboBox;
    TabSheet4: TTabSheet;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    rbAlwaysDataRec: TRadioButton;
    rbRecDataWithLimits: TRadioButton;
    TabSheet3: TTabSheet;
    Label6: TLabel;
    cbLimitOverGraph: TCheckBox;
    GroupBox4: TGroupBox;
    shBG: TShape;
    shGrid: TShape;
    shTrace: TShape;
    Label5: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    GroupBox5: TGroupBox;
    PaintBox1: TPaintBox;
    TabSheet6: TTabSheet;
    GroupBox11: TGroupBox;
    Label14: TLabel;
    lblUnit1: TLabel;
    Label16: TLabel;
    lblUnit2: TLabel;
    edMaxUserValue: TEdit;
    edMinUserValue: TEdit;
    GroupBox13: TGroupBox;
    TabSheet5: TTabSheet;
    GroupBox10: TGroupBox;
    rbPrintColor: TRadioButton;
    rbPrintBW: TRadioButton;
    Label7: TLabel;
    shCursor: TShape;
    edDataDir: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    cbCANInputNum: TComboBox;
    Label1: TLabel;
    Label23: TLabel;
    GroupBox6: TGroupBox;
    cbEOC: TCheckBox;
    edBaseUnit: TEdit;
    cbShowThresholds: TCheckBox;
    GroupBox15: TGroupBox;
    Label8: TLabel;
    edMinThreshold: TEdit;
    lblUnit5: TLabel;
    Label9: TLabel;
    edMaxThreshold: TEdit;
    lblUnit6: TLabel;
    btnHelp: TBitBtn;
    Label24: TLabel;
    shAverageTrace: TShape;
    cbShowAverageTrace: TCheckBox;
    edAverageNum: TEdit;
    Label25: TLabel;
    TabSheet1: TTabSheet;
    GroupBox9: TGroupBox;
    Label27: TLabel;
    edVRefMinus: TEdit;
    Label28: TLabel;
    edVRefPlus: TEdit;
    Label29: TLabel;
    edVRefDiv2: TEdit;
    btnCalVRef: TSpeedButton;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    GroupBox16: TGroupBox;
    cbCalInputNum: TComboBox;
    lblMsgCal: TLabel;
    btnStartVerif: TSpeedButton;
    edCalInput: TEdit;
    Label33: TLabel;
    Label34: TLabel;
    btnStopVerif: TSpeedButton;
    rgComNum: TRadioGroup;
    GroupBox17: TGroupBox;
    Label10: TLabel;
    edMaxGauge: TEdit;
    Label11: TLabel;
    GroupBox18: TGroupBox;
    Label15: TLabel;
    edFreeDiskLimit: TEdit;
    Label17: TLabel;
    Label21: TLabel;
    Label18: TLabel;
    edMaxGraphValue: TEdit;
    edMinGraphValue: TEdit;
    lblUnit4: TLabel;
    lblUnit3: TLabel;
    Label20: TLabel;
    edScreenUnit: TEdit;
    Label26: TLabel;
    edFactorUnit: TEdit;
    Label35: TLabel;
    cbRAZAfterAcq: TCheckBox;
    Label36: TLabel;
    edDefaultValue: TEdit;
    lblUnit7: TLabel;
    edScreenPrecision: TEdit;
    Label13: TLabel;
    Label19: TLabel;
    procedure rbAcqManuClick(Sender: TObject);
    procedure btnProgDateClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure shBGMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure tbTimerIntervalChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCalVRefClick(Sender: TObject);
    procedure cbCalInputNumChange(Sender: TObject);
    procedure btnStartVerifClick(Sender: TObject);
    procedure btnStopVerifClick(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure edBaseUnitChange(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    { Dclarations prives }
    startVerification: boolean;
    procedure MAJPreview;
    procedure GetUserPrefs;
    procedure RecordChanges;
    function ReadVal(address: string): integer;
  public
    { Dclarations publiques }
  end;

var
  fmOptions: TfmOptions;

implementation

uses
  rmMisc, prog_acq, main;

{$R *.DFM}

procedure TfmOptions.FormCreate(Sender: TObject);
begin
  PageControl1.activePage := TabSheet4;
  cbCalInputNum.ItemIndex := 0;
  cbCalInputNumChange(nil);
  startVerification := false;
end;

procedure TfmOptions.FormActivate(Sender: TObject);
begin
  GetUserPrefs;
  caption := 'Options pour "' + mainTitle + '"'; 
end;

procedure TfmOptions.rbAcqManuClick(Sender: TObject);
begin
  btnProgDate.enabled := rbAcqAuto.checked;
end;

procedure TfmOptions.btnProgDateClick(Sender: TObject);
var
  frm: TFmProgAcq;
begin
  try
    frm := TFmProgAcq.create(self);
    frm.showModal;
  finally
    frm.free;
  end;
end;

procedure TfmOptions.GetUserPrefs;
var
  ini: TIniFile;
  section: string;
begin
  // timer
  tbTimerInterval.position :=  10 - (fmPrincipale.timer1.Interval div 100);
  lblTimerInt.caption := intToStr(fmPrincipale.timer1.Interval) + ' ms';
  // couleurs
  shBG.Brush.color := fmPrincipale.BGColor;
  shGrid.Brush.color := fmPrincipale.GridColor;
  shTrace.Brush.color := fmPrincipale.TraceColor;
  shAverageTrace.Brush.color := fmPrincipale.AverageTraceColor;
  shCursor.Brush.color := fmPrincipale.CursorsColor;
  // rpertoire de destination des donnes enregistres
  try
    edDataDir.directory := DataDir;
  except
    edDataDir.directory := 'c:\';
  end;
  // interface matrielle - non trait pour le moment
  cbHardWare.enabled := false;
  cbHardWare.itemIndex := 0;

  section := 'Options-' + MainTitle;
  try
    ini := TIniFile.create(AppIniFile);

    // acquisition
    cbCANInputNum.ItemIndex := ini.ReadInteger(section, 'CANInputNum', 1) - 1;
    tbTimerInterval.Enabled := ini.ReadBool(section, 'TimerIntervalEnabled', true);
    rbAcqManu.checked := fmPrincipale.AcqMode = 'MANU';
    rbAcqAuto.checked := not rbAcqManu.checked;
    cbEOC.checked := ini.ReadBool(section, 'EOCControl', true);
    cbRAZAfterAcq.Checked := ini.ReadBool(section, 'RAZAfterAcq', false);
    // enregistrement
    rbAlwaysDataRec.checked := ini.ReadBool(section, 'AlwaysDataRec', true);
    rbRecDataWithLimits.checked := not rbAlwaysDataRec.checked;
    // echelles
    edBaseUnit.text := ini.ReadString(section, 'BaseUnit', '');
    edScreenUnit.text := ini.ReadString(section, 'ScreenUnit', '');
    edFactorUnit.text := ini.ReadString(section, 'FactorUnit', '1');
    edScreenPrecision.text := ini.ReadString(section, 'ScreenPrecision', '0');

    edAverageNum.text := ini.ReadString(section, 'AverageNum', '50');
    edMinUserValue.text := ini.ReadString(section, 'MinUserValue', '0');
    edMaxUserValue.text := ini.ReadString(section, 'MaxUserValue', '150');
    edMinGraphValue.text := ini.ReadString(section, 'MinGraphUserValue', '50');
    edMaxGraphValue.text := ini.ReadString(section, 'MaxGraphUserValue', '125');
    edMinThreshold.text := ini.ReadString(section, 'MinThreshold', '0');
    edMaxThreshold.text := ini.ReadString(section, 'MaxThreshold', '0');
    // affichage
    cbLimitOverGraph.checked := ini.ReadBool(section, 'LimitOverGraph', true);
    cbShowThresholds.checked := fmPrincipale.ShowThresholds;
    cbShowAverageTrace.checked := ini.ReadBool(section, 'ShowAverageTrace', false);
    // General
    rbPrintColor.checked := ini.ReadBool('General', 'PrintColor', false);
    rbPrintBW.checked := not rbPrintColor.checked;
    rgComNum.itemIndex := ini.ReadInteger('General', 'ComNum', 1) - 1;
    edMaxGauge.Text := ini.ReadString('General', 'MaxGauge', '30');
    edFreeDiskLimit.Text := ini.ReadString('General', 'FreeDiskLimit', '30');
    edDefaultValue.text := ini.ReadString(section, 'DefaultValue', '0');
  finally
    ini.free;
  end;
end;


procedure TfmOptions.shBGMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  with ColorDialog1 do begin
    color := (sender as TShape).brush.color;
    if execute then begin
      (sender as TShape).brush.color := color;
      MAJPreview;
    end;
  end;
end;

procedure TfmOptions.PaintBox1Paint(Sender: TObject);
begin
  MAJPreview;
end;

procedure TfmOptions.MAJPreview;
var
  X1, Y1, X2, Y2: integer;
begin
  with PaintBox1.canvas do begin
    // fond d'cran
    brush.color := shBG.brush.color;
    fillRect(Rect(0, 0, PaintBox1.Width, PaintBox1.Height));
    // grille
    pen.color := shGrid.brush.color;
    pen.style := psDot;
    X1 := 0;
    Y1 := PaintBox1.height div 2;
    X2 := PaintBox1.width;
    Y2 := PaintBox1.height div 2;
    moveTo(X1, Y1);
    lineTo(X2, Y2);
    // courbe
    pen.color := shTrace.brush.color;
    pen.style := psSolid;
    moveTo(0, 50);
    lineTo(35, 35);
    lineTo(45, 25);
    lineTo(60, 10);
    lineTo(70, 38);
    lineTo(90, 24);
    lineTo(width, 22);
    // courbe moyenne
    pen.color := shAverageTrace.brush.color;
    pen.style := psSolid;
    moveTo(0, 30);
    lineTo(35, 28);
    lineTo(45, 25);
    lineTo(60, 18);
    lineTo(70, 34);
    lineTo(90, 26);
    lineTo(width, 23);
    // curseur
    pen.color := shCursor.brush.color;
    pen.style := psSolid;
    moveTo(42, 0);
    lineTo(42, PaintBox1.height);
  end;
end;

procedure TfmOptions.btnOKClick(Sender: TObject);
begin
  RecordChanges;
end;

procedure TfmOptions.RecordChanges;
var
  ini: TIniFile;
  section: string;
begin
  section := 'Options-' + MainTitle;
  try
    ini := TIniFile.create(AppIniFile);
    ini.WriteInteger(section, 'CANInputNum', cbCANInputNum.ItemIndex + 1);
    ini.WriteBool('General', 'PrintColor', rbPrintColor.checked);
    ini.WriteInteger(section, 'TimerInterval', (10 - tbTimerInterval.position) * 100);
    ini.WriteBool(section, 'EOCControl', cbEOC.checked);
    ini.WriteBool(section, 'RAZAfterAcq', cbRAZAfterAcq.checked);
    ini.WriteBool(section, 'ShowAverageTrace', cbShowAverageTrace.checked);
    ini.WriteBool(section, 'AcquisitionMode', rbAcqManu.checked);
    ini.WriteString(section, 'DataDir', edDataDir.directory);
    ini.WriteBool(section, 'AlwaysDataRec', rbAlwaysDataRec.checked);

    ini.WriteString(section, 'BaseUnit', edBaseUnit.text);
    ini.WriteString(section, 'ScreenUnit', edScreenUnit.text);
    ini.WriteString(section, 'FactorUnit', edFactorUnit.text);
    ini.WriteString(section, 'ScreenPrecision', edScreenPrecision.text);

    ini.WriteString(section, 'AverageNum', edAverageNum.text);
    ini.WriteString(section, 'MinUserValue', edMinUserValue.text);
    ini.WriteString(section, 'MaxUserValue', edMaxUserValue.text);
    ini.WriteString(section, 'MinGraphUserValue', edMinGraphValue.text);
    ini.WriteString(section, 'MaxGraphUserValue', edMaxGraphValue.text);
    ini.WriteString(section, 'MinThreshold', edMinThreshold.text);
    ini.WriteString(section, 'MaxThreshold', edMaxThreshold.text);
    ini.WriteInteger(section, 'BackGroundColor', shBG.brush.color);
    ini.WriteInteger(section, 'GridColor', shGrid.brush.color);
    ini.WriteInteger(section, 'TraceColor', shTrace.brush.color);
    ini.WriteInteger(section, 'AverageTraceColor', shAverageTrace.brush.color);
    ini.WriteInteger(section, 'CursorColor', shCursor.brush.color);
    ini.WriteBool(section, 'LimitOverGraph', cbLimitOverGraph.checked);
    ini.WriteBool('General', 'ShowThresholds', cbShowThresholds.checked);
    ini.WriteInteger('General', 'ComNum', rgComNum.itemIndex + 1);
    ini.WriteString('General', 'MaxGauge', edMaxGauge.Text);
    ini.WriteString('General', 'FreeDiskLimit', edFreeDiskLimit.Text);
    ini.WriteString(section, 'DefaultValue', edDefaultValue.Text);
  finally
    ini.free;
  end;
end;

procedure TfmOptions.tbTimerIntervalChange(Sender: TObject);
begin
  lblTimerInt.caption := intToStr((10 - tbTimerInterval.position) * 100) + ' ms';
end;

function TfmOptions.ReadVal(address: string): integer;
var
  i, j, NumSmp: integer;
  dataValue, finalValue: integer;
begin
  NumSmp := 100;
  finalValue := 0;
  for j := 0 to NumSmp do begin
    fmPrincipale.ReadData(address);
    // traduction de la valeur binaire lue, en dcimal
    dataValue := 0;
    for i := 9 downTo 0 do begin
      case i of
        9 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 512;
        8 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 256;
        7 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 128;
        6 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 64;
        5 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 32;
        4 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 16;
        3 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 8;
        2 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 4;
        1 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 2;
        0 : if fmPrincipale.data[i] = 1 then dataValue := dataValue + 1;
      end;
    end;
    if j > 0 then finalValue := finalValue + dataValue;
  end;
  finalValue := finalValue div NumSmp;
  result := finalValue;
end;

procedure TfmOptions.btnCalVRefClick(Sender: TObject);
var
  val: integer;
begin
  // vrification VRef-
  val := ReadVal(byteToBits(12, 4));
  if val > 5 then edVRefMinus.font.color := clRed else edVRefMinus.font.color := clBlack;
  edVRefMinus.text := intToStr(val);

  // vrification VRef+
  val := ReadVal(byteToBits(13, 4));
  if (val < 1018) then edVRefPlus.font.color := clRed else edVRefPlus.font.color := clBlack;
  edVRefPlus.text := intToStr(val);

  // vrification (VRef- - VRef+) div 2
  val := ReadVal(byteToBits(11, 4));
  if (val < 509) or (val > 514) then edVRefDiv2.font.color := clRed else edVRefDiv2.font.color := clBlack;
  edVRefDiv2.text := intToStr(val);
end;

procedure TfmOptions.cbCalInputNumChange(Sender: TObject);
begin
  with cbCalInputNum do begin
    case itemIndex of
      0..3 : lblMsgCal.caption := 'Injectez un signal sinus de +18dBu';
      4..10: lblMsgCal.caption := 'Injectez une tension continue de +5V';
    end;
  end;
end;

procedure TfmOptions.btnStartVerifClick(Sender: TObject);
var
  ad: string;
  val: integer;
begin
  startVerification := true;
  btnCalVRef.enabled := false;
  btnStartVerif.enabled := false;
  btnStopVerif.enabled := true;
  btnOK.enabled := false;
  btnCancel.enabled := false;
  cbCalInputNum.enabled := false;
  repeat
    application.processMessages;
    val := ReadVal(byteToBits(cbCalInputNum.itemIndex, 4));
    if (val < 1018) then edCalInput.font.color := clRed else edCalInput.font.color := clBlack;
    edCalInput.text := intToStr(val);
  until startVerification = false;
end;

procedure TfmOptions.btnStopVerifClick(Sender: TObject);
begin
  startVerification := false;
  btnCalVRef.enabled := true;
  btnStartVerif.enabled := true;
  btnStopVerif.enabled := false;
  btnOK.enabled := true;
  btnCancel.enabled := true;
  cbCalInputNum.enabled := true;
end;

procedure TfmOptions.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  allowChange := not startVerification;
end;

procedure TfmOptions.edBaseUnitChange(Sender: TObject);
begin
  lblUnit1.caption := edBaseUnit.text;
  lblUnit2.caption := edBaseUnit.text;
  lblUnit3.caption := edBaseUnit.text;
  lblUnit4.caption := edBaseUnit.text;
  lblUnit5.caption := edBaseUnit.text;
  lblUnit6.caption := edBaseUnit.text;
  lblUnit7.caption := edBaseUnit.text;
end;

procedure TfmOptions.PageControl1Change(Sender: TObject);
begin
  if pageControl1.ActivePage = tabSheet1 then
    cbCalInputNum.ItemIndex := cbCANInputNum.ItemIndex;
end;

end.
