unit testgene;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TfmTestGenerator = class(TForm)
    Bevel1: TBevel;
    rgWaveForm: TRadioGroup;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel2: TBevel;
    gbAmplitude: TGroupBox;
    graph: TPaintBox;
    Label1: TLabel;
    edAmpRate: TEdit;
    UpDown1: TUpDown;
    GroupBox1: TGroupBox;
    edPer: TEdit;
    UpDown2: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure rgWaveFormClick(Sender: TObject);
    procedure graphPaint(Sender: TObject);
    procedure edAmpRateChange(Sender: TObject);
    procedure edPerChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Dclarations prives }
    TblMes: array[0..511] of integer;
    per, amp, factor: integer;
    procedure refreshControls;
    procedure DrawGraph;
  public
    { Dclarations publiques }
  end;

var
  fmTestGenerator: TfmTestGenerator;

implementation

uses
  main;

{$R *.DFM}

procedure TfmTestGenerator.FormCreate(Sender: TObject);
begin
  refreshControls;
end;

procedure TfmTestGenerator.refreshControls;
begin
  rgWaveForm.ItemIndex := 0;
end;


procedure TfmTestGenerator.rgWaveFormClick(Sender: TObject);
begin
  graphPaint(nil);
end;

procedure TfmTestGenerator.DrawGraph;

  procedure GenerateSinus;
  var
    y, i: integer;
    tmp: real;
  begin
    for i := 0 to 511 do begin
      tmp := amp * (1 + (sin(((2 * Pi * i) * per) / graph.width)));
      // + (graph.Height div 2);
      tmp := (tmp * factor) / 100;
      y := trunc(tmp);
      TblMes[i] := y;
    end;
  end;

  procedure GenerateSquare;
  var
    i: integer;
  begin
    for i := 0 to 511 do
      TblMes[i] := 0;
  end;

  procedure GenerateSaw;
  var
    i: integer;
  begin
    for i := 0 to 511 do
      TblMes[i] := 0;
  end;

  procedure GeneratePulse;
  var
    i: integer;
  begin
    for i := 0 to 511 do
      TblMes[i] := 0;
  end;

  procedure GenerateVcc;
  var
    i: integer;
  begin
    for i := 0 to 511 do
      TblMes[i] := trunc((amp * 2 * factor) / 100) ;
  end;

  procedure GenerateUser;
  var
    i: integer;
  begin
    for i := 0 to 511 do
      TblMes[i] := 0;
  end;

var
  i, y: integer;
begin
  amp := 512;
  try
    factor := strToInt(edAmpRate.text);
  except
    factor := 100;
  end;
  try
    per := strToInt(edPer.text);
  except
    per := 1;
  end;
  with graph do begin

    // remplissage tableau avec des valeurs fonction du type d'onde demand
    case rgWaveForm.itemIndex of
      0 : GenerateSinus;
      1 : GenerateSquare;
      2 : GenerateSaw;
      3 : GeneratePulse;
      4 : GenerateVcc;
      5 : GenerateUser;
    end;

    // dessin  partir des valeurs du tableau
    canvas.Brush.Color := clBlack;
    canvas.pen.Color := clLime;
    canvas.font.Color := clAqua;
    canvas.Rectangle(0, 0, width, height);
    canvas.moveTo(0, height div 2);
    for i := 0 to 511 do begin
      y := trunc(graph.height - (tblMes[i] * (graph.Height / 1023)));
      canvas.LineTo(i, y);
    end;
  end;
end;

procedure TfmTestGenerator.graphPaint(Sender: TObject);
begin
  DrawGraph;
end;

procedure TfmTestGenerator.edAmpRateChange(Sender: TObject);
begin
  DrawGraph;
end;

procedure TfmTestGenerator.edPerChange(Sender: TObject);
begin
  DrawGraph;
end;

procedure TfmTestGenerator.BitBtn2Click(Sender: TObject);
var
  sMsg: string;
  i: integer;
begin
  sMsg := 'Les dernires mesures seront ecrases.' + CRLF + 'Voulez-vous continuer ?';
  if messageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    for i := 0 to 511 do
      fmPrincipale.TblMes1[i].iValue := tblMes[i];
    modalResult := mrOK;
  end;
end;

end.
