unit jdb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, Menus, ImgList;

type
  TFmJdB = class(TForm)
    ToolBar1: TToolBar;
    btnSauverSous: TToolButton;
    Calendar: TDateTimePicker;
    ToolButton2: TToolButton;
    btnQuitter: TToolButton;
    ToolButton3: TToolButton;
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    mnuFichier: TMenuItem;
    mnuSauverSous: TMenuItem;
    N1: TMenuItem;
    mnuQuitter: TMenuItem;
    btnImageList: TImageList;
    mnuImprimer: TMenuItem;
    N2: TMenuItem;
    btnImprimer: TToolButton;
    SaveDialog1: TSaveDialog;
    mnuEdit: TMenuItem;
    mnuCopier: TMenuItem;
    N3: TMenuItem;
    mnuToutEffacer: TMenuItem;
    Annuler1: TMenuItem;
    N4: TMenuItem;
    Couper1: TMenuItem;
    btnCopier: TToolButton;
    ToolButton5: TToolButton;
    btnEffacer: TToolButton;
    mnuOuvrir: TMenuItem;
    btnOuvrir: TToolButton;
    OpenDialog1: TOpenDialog;
    sbJDB: TStatusBar;
    mnuOptions: TMenuItem;
    mnuFormOnTop: TMenuItem;
    btnStartAcq: TToolButton;
    btnStopAcq: TToolButton;
    ToolButton1: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure btnImprimerClick(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure mnuSauverSousClick(Sender: TObject);
    procedure mnuQuitterClick(Sender: TObject);
    procedure mnuCopierClick(Sender: TObject);
    procedure mnuToutEffacerClick(Sender: TObject);
    procedure Annuler1Click(Sender: TObject);
    procedure Couper1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure mnuOuvrirClick(Sender: TObject);
    procedure CalendarChange(Sender: TObject);
    procedure mnuFormOnTopClick(Sender: TObject);
    procedure btnStartAcqClick(Sender: TObject);
    procedure btnStopAcqClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure SetEditRect;
    function GetJdBFileNameFromDate(d: TDateTime): string;
    function SaveJDB(sFile: TFileName): boolean;
    procedure LoadJDB(sFile: TFileName);
  public
    { Dclarations publiques }
    oldValue: integer;
    LastErrorString: string;
    LastEventString: string;
    procedure insertEvent(s: string; cl: TColor);
    procedure insertStartEvent(s: string);
    procedure insertEndEvent(s: string);
    procedure insertError(s: string);
    procedure insertStartAcq;
    procedure insertStopAcq;
  end;

var
  FmJdB: TFmJdB;

implementation

uses
  main;

{$R *.DFM}

procedure TFmJdB.FormCreate(Sender: TObject);
begin
  Calendar.date := now;
  CalendarChange(nil);
  richEdit1.modified := false;
  btnStartAcq.enabled := fmPrincipale.btnStartAcq.enabled;
  btnStopAcq.enabled := fmPrincipale.btnStopAcq.enabled;

  // positionnement des fentres
  try
    top := 0;
    left := 0;
  except
  end;
  if screen.Height > (fmPrincipale.Height + fmJdb.Height) then begin
    fmPrincipale.Top := fmJdb.Height;
    fmPrincipale.left := (screen.Width - fmPrincipale.width) div 2;
  end;
end;

procedure TFmJdB.insertError(s: string);
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := clRed;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : ' + s);
    selAttributes.Color := clBlack;
  end;
end;

procedure TFmJdB.insertEvent(s: string; cl: TColor);
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := cl;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : ' + s);
    selAttributes.Color := clBlack;
  end;
end;

procedure TFmJdB.insertStartEvent(s: string);
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := clRed;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : ' + s);
    selAttributes.Color := clBlack;
  end;
end;

procedure TFmJdB.insertEndEvent(s: string);
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := clGreen;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : ' + s);
    selAttributes.Color := clBlack;
  end;
end;

procedure TFmJdB.insertStartAcq;
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := clFuchsia;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : Dbut acquisition');
    selAttributes.Color := clBlack;
  end;
end;

procedure TFmJdB.insertStopAcq;
begin
  with RichEdit1 do begin
    SelStart := Length(Text);
    selAttributes.Color := clBlue;
    Lines.add(dateToStr(now) + ' ' + timeToStr(now) + ' : Acquisition stoppe');
    selAttributes.Color := clBlack;
    Lines.add('');
  end;
end;

procedure TFmJdB.btnImprimerClick(Sender: TObject);
begin
  with RichEdit1 do begin
    print('JDB Mesureur universel');
  end;
end;

procedure TFmJdB.RichEdit1Change(Sender: TObject);
var
  BeginAnnee, BeginMois, BeginJour: word;
  NowAnnee, NowMois, NowJour: word;
  sFile: string;
begin
  SetEditRect;
  with richEdit1 do begin
    modified := true;
  end;

  // sauvegard JDB ?
  decodeDate(fmPrincipale.BeginDateTime, BeginAnnee, BeginMois, BeginJour);
  decodeDate(Now, NowAnnee, NowMois, NowJour);
  if ((BeginAnnee < NowAnnee) or (BeginMois < NowMois) or (BeginJour < NowJour)) then begin
    sFile := GetJdBFileNameFromDate(fmPrincipale.BeginDateTime);
    if SaveJdB(cheminApp + 'data\' + sFile) then begin
      fmPrincipale.BeginDateTime := now;
      fmPrincipale.OverMinThrCount := 0;
      fmPrincipale.OverMaxThrCount := 0;
      richEdit1.clear;
      fmJDB.insertEvent('Sauvegarde JDB effectue dans "' + extractFileName(sFile) + '"', clGray);
      richEdit1.modified := false;
    end else begin
      fmJDB.insertEvent('Sauvegarde JDB impossible dans "' + extractFileName(sFile) + '"', clRed);
    end;
  end;
end;

procedure TFmJdB.SetEditRect;
var
  r: TRect;
begin
  with richEdit1 do begin
    r := rect(0, 0, clientWidth, clientHeight);
    sendMessage(handle, EM_SETRECT, 0, longint(@r));
  end;
end;

procedure TFmJdB.mnuOuvrirClick(Sender: TObject);
begin
  if fmPrincipale.timer1.enabled then exit;
  with openDialog1 do begin
    initialDir := cheminApp + 'data';
    if execute then LoadJDB(FileName);
  end;
end;

procedure TFmJdB.mnuSauverSousClick(Sender: TObject);
begin
  with saveDialog1 do begin
    FileName := GetJdBFileNameFromDate(calendar.Date);
    initialDir := cheminApp + 'data\';
    if execute then SaveJDB(FileName);
  end;
end;

function TFmJdB.SaveJDB(sFile: TFileName): boolean;
begin
  with richEdit1 do begin
    try
      lines.saveToFile(sFile);
      modified := false;
      result := true;
    except
      result := false;
    end;
  end;
end;

procedure TFmJdB.LoadJDB(sFile: TFileName);
begin
  with richEdit1 do begin
    try
      lines.loadFromFile(sFile);
      Lines.add('');
      modified := false;
    except
    end;
  end;
end;

procedure TFmJdB.mnuQuitterClick(Sender: TObject);
begin
  close;
end;

procedure TFmJdB.Couper1Click(Sender: TObject);
begin
  with RichEdit1 do begin
    cutToClipboard;
  end;
end;

procedure TFmJdB.mnuCopierClick(Sender: TObject);
begin
  with RichEdit1 do begin
    copyToClipboard;
  end;
end;

procedure TFmJdB.mnuToutEffacerClick(Sender: TObject);
var
  sMsg: string;
begin
  sMsg := 'Cette commande ne pourra pas tre annule.' + CR + 'Confirmer l''effacement?';
  if messageDlg(sMsg, mtConfirmation, [mbYes, mbNo, mbCancel], 0) <> mrYes then exit;
  with RichEdit1 do begin
    clear;
  end;
end;

procedure TFmJdB.Annuler1Click(Sender: TObject);
begin
  with RichEdit1 do begin
    if HandleAllocated then sendMessage(Handle, EM_UNDO, 0, 0);
  end;
end;

procedure TFmJdB.FormResize(Sender: TObject);
begin
  SetEditRect;
end;

procedure TFmJdB.FormPaint(Sender: TObject);
begin
  SetEditRect;
end;

procedure TFmJdB.CalendarChange(Sender: TObject);
var
  sFile: string;
begin
  // nom du fichier JDB en fonction de la date
  sFile := cheminApp + 'data\' + GetJdBFileNameFromDate(Calendar.date);
  if fileExists(sFile) then begin
    loadJdB(sFile);
    caption := 'Journal de bord du ' + dateToStr(Calendar.date);
  end else begin
    caption := 'Aucun journal de bord enregistr  la date du ' + dateToStr(Calendar.date);
    richEdit1.clear;
  end;
end;

function TFmJdB.GetJdBFileNameFromDate(d: TDateTime): string;
var
  annee, mois, jour: word;
  sAnnee, sMois, sJour: string;
begin
  decodeDate(d, annee, mois, jour);
  // jour
  sJour := inttostr(jour);
  sJour := format('%2s', [sJour]);
  while pos(' ', sJour) > 0 do sJour[Pos(' ' , sJour)] := '0';
  // mois
  sMois := inttostr(mois);
  sMois := format('%2s', [sMois]);
  while pos(' ', sMois) > 0 do sMois[Pos(' ' , sMois)] := '0';
  // annee
  sAnnee := inttostr(annee);
  result := sJour + sMois + sAnnee + '.rtf';
end;

procedure TFmJdB.mnuFormOnTopClick(Sender: TObject);
begin
  mnuFormOnTop.checked := not mnuFormOnTop.checked;
  if fmPrincipale.timer1.enabled then exit;
  richEdit1.lines.SaveToFile('temp.rtf');
  if mnuFormOnTop.checked then FmJdB.formStyle := fsStayOnTop else FmJdB.formStyle := fsNormal;
  richEdit1.lines.LoadFromFile('temp.rtf');
  if fileExists('temp.rtf') then deleteFile('temp.rtf');
end;

procedure TFmJdB.btnStartAcqClick(Sender: TObject);
begin
  fmPrincipale.mnuDemarrerAcqClick(nil);
end;

procedure TFmJdB.btnStopAcqClick(Sender: TObject);
begin
  fmPrincipale.mnuStopperAcqClick(nil);
end;

end.
