unit report01;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, quickrpt, Qrctrls, StdCtrls;

type
  TfmReport01 = class(TForm)
    QuickRep1: TQuickRep;
    QRlblTitle: TQRLabel;
    QRLabel2: TQRLabel;
    lblPrintDate: TQRLabel;
    QRImage1: TQRImage;
    QRLlblScale5: TQRLabel;
    QRLlblScale1: TQRLabel;
    QRLlblScale4: TQRLabel;
    QRLlblScale3: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    lblDebut: TQRLabel;
    lblNumPts: TQRLabel;
    lblFin: TQRLabel;
    QRLabel9: TQRLabel;
    QRLabel10: TQRLabel;
    lblMaxVal: TQRLabel;
    QRLabel11: TQRLabel;
    QRLlblScale2: TQRLabel;
    QRlblSeuilHaut: TQRLabel;
    QRlblSeuilBas: TQRLabel;
    QRLabel3: TQRLabel;
    QRUserRem: TQRMemo;
    QRLabel1: TQRLabel;
    lblMinVal: TQRLabel;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure RefreshReport;
  end;

var
  fmReport01: TfmReport01;

implementation

uses
  rmMisc, main, UserComm;

{$R *.DFM}

procedure TfmReport01.RefreshReport;
var
  sMsg: string;
  bmp: TBitmap;
  RectOrigin, RectDest: TRect;
  i, val, min, max: integer;
  s, dt, dtMin, dtMax: string;
begin
  // commentaire utilisateur
  sMsg := 'Voulez-vous ajouter un commentaire au rapport ?';
  if messageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    if fmUserComment.showModal = mrOK then begin
      fmUserComment.memo1.Refresh;
      QRUserRem.lines.Assign(fmUserComment.memo1.Lines);
      QRUserRem.Refresh;
    end;

  // titre
  QRlblTitle.caption := mainTitle;

  // date d'impression du rapport
  lblPrintDate.caption := dateToStr(now) + ' - ' + TimeToStr(now);

  // labels d'echelle
  QRLlblScale1.caption := fmPrincipale.lblScale1.caption;
  QRLlblScale2.caption := fmPrincipale.lblScale2.caption;
  QRLlblScale3.caption := fmPrincipale.lblScale3.caption;
  QRLlblScale4.caption := fmPrincipale.lblScale4.caption;
  QRLlblScale5.caption := fmPrincipale.lblScale5.caption;

  // seuils
  s := fmPrincipale.UserValueToScreenValue(fmPrincipale.minThreshold);
  QRlblSeuilBas.caption := 'Seuil bas fix  ' + s + ' ' + fmPrincipale.ScreenUnit;
  s := fmPrincipale.UserValueToScreenValue(fmPrincipale.maxThreshold);
  QRlblSeuilHaut.caption := 'Seuil haut fix  ' + s + ' ' + fmPrincipale.ScreenUnit;

  // dbut des mesures
  for i := 0 to 511 do
    if fmPrincipale.tblMes1[i].sDateTime <> '' then begin
      dt := fmPrincipale.tblMes1[i].sDateTime;
      break;
    end;
  lblNumPts.caption := intToStr(512 - i);
  if dt = '' then dt := 'Aucune mesure ralise';
  lblDebut.caption := dt;

  // fin des mesures
  dt := fmPrincipale.tblMes1[511].sDateTime;
  if dt = '' then dt := 'Aucune mesure ralise';
  lblFin.caption := dt;

  // recherche des max et min
  max := 0;
  min := 1024;
  for i := 0 to 511 do begin
    val := fmPrincipale.tblMes1[i].iValue;
    if (val < min) and (fmPrincipale.tblMes1[i].sDateTime <> '') then begin
      min := val;
      dtMin := fmPrincipale.tblMes1[i].sDateTime;
    end;
    if (val > max) and (fmPrincipale.tblMes1[i].sDateTime <> '') then begin
      max := val;
      dtMax := fmPrincipale.tblMes1[i].sDateTime;
    end;
  end;
  if (lblDebut.caption <> 'Aucune mesure ralise') and (lblFin.caption <> 'Aucune mesure ralise') then begin
    if dtMin <> '' then
      lblMinVal.caption := fmPrincipale.CANValueToScreenValue(min) + ' ' + fmPrincipale.ScreenUnit + ' (' + dtMin + ')';
    if dtMax <> '' then
      lblMaxVal.caption := fmPrincipale.CANValueToScreenValue(max) + ' ' + fmPrincipale.ScreenUnit + ' (' + dtMax + ')';
  end;

  // copie de l'image graphique
  // passage par un bitmap temporaire
  if not fmPrincipale.printColor then fmPrincipale.DrawGraph(clWhite, clBlack);
  RectOrigin := rect(0, 0, fmPrincipale.paintbox1.width, fmPrincipale.paintbox1.height);
  RectDest := rect(1, 1, fmPrincipale.paintbox1.width + 1, fmPrincipale.paintbox1.height + 1);
  try
    bmp := TBitmap.create;
    bmp.width := fmPrincipale.paintbox1.width + 2;
    bmp.height := fmPrincipale.paintbox1.height + 2;
    bmp.canvas.rectangle(0, 0, bmp.width, bmp.height);
    bmp.canvas.CopyRect(RectDest, fmPrincipale.paintbox1.canvas, RectOrigin);
    QRImage1.picture.bitmap := bmp;
  finally
    bmp.free;
  end;

end;

end.
